LogTo("/home/agustin/gap-4.10.1/bin/ufo/cleft-br2a-q-1.log");;

LoadPackage("GBNP");

GBNP.ConfigPrint("y2","y1","x2","x1");

y2:=[[[1]],[1]];
y1:=[[[2]],[1]];
x2:=[[[3]],[1]];
x1:=[[[4]],[1]];

#########################################################
Print("\n \n Case lambda1, lambda2, lambda 3 nonzero\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;
t3:=Indeterminate(Rationals,"t3");;

#only one matrix 

F1:=1;;
q:=E(3);
q11:=q*F1;;
q12:=-1;;
q21:=1;;
q22:=-1;;


y13:=[[[2,2,2]],[F1]];
y22:=[[[1,1]],[F1]];
x13:=[[[4,4,4]],[F1]];
x22:=[[[3,3]],[F1]];

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);
y22d:=AddNP(y22,[[[]],[F1]],1,-t2);

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;


K1:=[
b11,b12,b21,b22,
y13d,x13,
y22d,x22
];;

Print("\n The ideal is \n");
PrintNPList(K1);
G1:=SGrobner(K1);

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;

d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;

d11212:=StrongNormalFormNP(AddNP(MulNP(d112,d12),MulNP(d12,d112),1,-q11^2*q12^2*q21*q22),G1);;

y11212:=StrongNormalFormNP(AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22),G1);;
x11212:=StrongNormalFormNP(AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22),G1);;

s11212:=AddNP(y11212,x11212,1,1);;

r11212:=StrongNormalFormNP(AddNP(d11212,s11212,1,-1),G1);

Print("\n The difference is \n");
PrintNP(r11212);


y11212d:=AddNP(y11212,[[[]],[F1]],1,-t3);;

K2:=[
b11,b12,b21,b22,
y13d,x13,
y22d,x22,
y11212d,x11212
];;

Print("\n The ideal is \n");
PrintNPList(K2);
G2:=SGrobner(K2);

G3:=G2;;

fna2:=StrongNormalFormNP(MulNP(d112,d112),G3);;
fna3:=StrongNormalFormNP(MulNP(fna2,d112),G3);;
fna4:=StrongNormalFormNP(MulNP(fna3,d112),G3);;
fna5:=StrongNormalFormNP(MulNP(fna4,d112),G3);;
fna6:=StrongNormalFormNP(MulNP(fna5,d112),G3);;

xxna2:=StrongNormalFormNP(MulNP(x112,x112),G3);;
xxna3:=StrongNormalFormNP(MulNP(xxna2,x112),G3);;
xxna4:=StrongNormalFormNP(MulNP(xxna3,x112),G3);;
xxna5:=StrongNormalFormNP(MulNP(xxna4,x112),G3);;
xxna6:=StrongNormalFormNP(MulNP(xxna5,x112),G3);;

yyna2:=StrongNormalFormNP(MulNP(y112,y112),G3);;
yyna3:=StrongNormalFormNP(MulNP(yyna2,y112),G3);;
yyna4:=StrongNormalFormNP(MulNP(yyna3,y112),G3);;
yyna5:=StrongNormalFormNP(MulNP(yyna4,y112),G3);;
yyna6:=StrongNormalFormNP(MulNP(yyna5,y112),G3);;

s112:=AddNP(yyna6,xxna6,1,1);;
r112:=StrongNormalFormNP(AddNP(fna6,s112,1,-1),G3);

Print("\n The difference is \n");
PrintNP(r112);


