LogTo("/home/edwin/br(2,a)/lift-br2a-M-N-6.log");;

LoadPackage("GBNP");

GBNP.ConfigPrint("g_{2}","g_{1}","a_{2}","a_{1}","y_{2}","y_{1}");

g2:=[[[1]],[1]];
g1:=[[[2]],[1]];
a2:=[[[3]],[1]];
a1:=[[[4]],[1]];
y2:=[[[5]],[1]];
y1:=[[[6]],[1]];


#########################################################
Print("\n \n Case lambda1 lambda 2 nonzero, q21=1\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F:=Field(t1,t2);;
F1:=One(F);;
q:=E(3);;
q11:=q*F1;;
q12:=-q*F1;;
q21:=1;;
q22:=-q^2*F1;;

a13:=[[[4,4,4]],[F1]];;
a26:=[[[3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y26:=[[[5,5,5,5,5,5]],[F1]];;
g13:=[[[2,2,2]],[F1]];;
g26:=[[[1,1,1,1,1,1]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a13d:=AddNP(AddNP(a13,[[[]],[F1]],1,-t1),g13,F1,t1);;
y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
a26d:=AddNP(AddNP(a26,[[[]],[F1]],1,-t2),g26,F1,t2);; 
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13d,a13d,
y26d,a26d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;
anb5:=StrongNormalFormNP(MulNP(anb4,a112),G1);;
anb6:=StrongNormalFormNP(MulNP(anb5,a112),G1);;

g116:=StrongNormalFormNP(MulNP(g13,MulNP(g13,MulNP(g13,g13))),G1);;
gnb6:=StrongNormalFormNP(MulNP(g116,g26),G1);;

ynb6g:=MulNP(ynb6,gnb6);;

s112:=AddNP(anb6,ynb6g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);


#########################################################
Print("\n \n Case lambda1 lambda2 nonzero, q21=E(3)\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F:=Field(t1,t2);;
F1:=One(F);;
q:=E(3);;
q11:=q*F1;;
q12:=-1;;
q21:=q*F1;;
q22:=-q^2*F1;;

a13:=[[[4,4,4]],[F1]];;
a26:=[[[3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y26:=[[[5,5,5,5,5,5]],[F1]];;
g13:=[[[2,2,2]],[F1]];;
g26:=[[[1,1,1,1,1,1]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a13d:=AddNP(AddNP(a13,[[[]],[F1]],1,-t1),g13,F1,t1);;
y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
a26d:=AddNP(AddNP(a26,[[[]],[F1]],1,-t2),g26,F1,t2);;
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13d,a13d,
y26d,a26d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;
anb5:=StrongNormalFormNP(MulNP(anb4,a112),G1);;
anb6:=StrongNormalFormNP(MulNP(anb5,a112),G1);;

g116:=StrongNormalFormNP(MulNP(g13,MulNP(g13,MulNP(g13,g13))),G1);;
gnb6:=StrongNormalFormNP(MulNP(g116,g26),G1);;

ynb6g:=MulNP(ynb6,gnb6);;

s112:=AddNP(anb6,ynb6g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 lambda2 nonzero, q21=E(3)^2\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F:=Field(t1,t2);;
F1:=One(F);;
q:=E(3);;
q11:=q*F1;;
q12:=-q^2*F1;;
q21:=q^2*F1;;
q22:=-q^2*F1;;

a13:=[[[4,4,4]],[F1]];;
a26:=[[[3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y26:=[[[5,5,5,5,5,5]],[F1]];;
g13:=[[[2,2,2]],[F1]];;
g26:=[[[1,1,1,1,1,1]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a13d:=AddNP(AddNP(a13,[[[]],[F1]],1,-t1),g13,F1,t1);;
y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
a26d:=AddNP(AddNP(a26,[[[]],[F1]],1,-t2),g26,F1,t2);;
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13d,a13d,
y26d,a26d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;
anb5:=StrongNormalFormNP(MulNP(anb4,a112),G1);;
anb6:=StrongNormalFormNP(MulNP(anb5,a112),G1);;

g116:=StrongNormalFormNP(MulNP(g13,MulNP(g13,MulNP(g13,g13))),G1);;
gnb6:=StrongNormalFormNP(MulNP(g116,g26),G1);;

ynb6g:=MulNP(ynb6,gnb6);;

s112:=AddNP(anb6,ynb6g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 nonzero lambda 2 zero, q21=1\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F:=Field(t1,t2);;
F1:=One(F);;
q:=E(3);;
q11:=q*F1;;
q12:=-q*F1;;
q21:=1;;
q22:=-q^2*F1;;

a13:=[[[4,4,4]],[F1]];;
a26:=[[[3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y26:=[[[5,5,5,5,5,5]],[F1]];;
g13:=[[[2,2,2]],[F1]];;
g26:=[[[1,1,1,1,1,1]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a13d:=AddNP(AddNP(a13,[[[]],[F1]],1,-t1),g13,F1,t1);;
y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
a26d:=AddNP(AddNP(a26,[[[]],[F1]],1,-t2),g26,F1,t2);;
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13d,a13d,
y26,a26,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;
anb5:=StrongNormalFormNP(MulNP(anb4,a112),G1);;
anb6:=StrongNormalFormNP(MulNP(anb5,a112),G1);;

g116:=StrongNormalFormNP(MulNP(g13,MulNP(g13,MulNP(g13,g13))),G1);;
gnb6:=StrongNormalFormNP(MulNP(g116,g26),G1);;

ynb6g:=MulNP(ynb6,gnb6);;

s112:=AddNP(anb6,ynb6g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);


#########################################################
Print("\n \n Case lambda1 nonzero lambda2 zero, q21=E(3)\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F:=Field(t1,t2);;
F1:=One(F);;
q:=E(3);;
q11:=q*F1;;
q12:=-1;;
q21:=q*F1;;
q22:=-q^2*F1;;

a13:=[[[4,4,4]],[F1]];;
a26:=[[[3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y26:=[[[5,5,5,5,5,5]],[F1]];;
g13:=[[[2,2,2]],[F1]];;
g26:=[[[1,1,1,1,1,1]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a13d:=AddNP(AddNP(a13,[[[]],[F1]],1,-t1),g13,F1,t1);;
y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
a26d:=AddNP(AddNP(a26,[[[]],[F1]],1,-t2),g26,F1,t2);;
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13d,a13d,
y26,a26,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;
anb5:=StrongNormalFormNP(MulNP(anb4,a112),G1);;
anb6:=StrongNormalFormNP(MulNP(anb5,a112),G1);;

g116:=StrongNormalFormNP(MulNP(g13,MulNP(g13,MulNP(g13,g13))),G1);;
gnb6:=StrongNormalFormNP(MulNP(g116,g26),G1);;

ynb6g:=MulNP(ynb6,gnb6);;

s112:=AddNP(anb6,ynb6g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 nonzero lambda2 zero, q21=E(3)^2\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F:=Field(t1,t2);;
F1:=One(F);;
q:=E(3);;
q11:=q*F1;;
q12:=-q^2*F1;;
q21:=q^2*F1;;
q22:=-q^2*F1;;

a13:=[[[4,4,4]],[F1]];;
a26:=[[[3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y26:=[[[5,5,5,5,5,5]],[F1]];;
g13:=[[[2,2,2]],[F1]];;
g26:=[[[1,1,1,1,1,1]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a13d:=AddNP(AddNP(a13,[[[]],[F1]],1,-t1),g13,F1,t1);;
y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
a26d:=AddNP(AddNP(a26,[[[]],[F1]],1,-t2),g26,F1,t2);;
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13d,a13d,
y26,a26,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;
anb5:=StrongNormalFormNP(MulNP(anb4,a112),G1);;
anb6:=StrongNormalFormNP(MulNP(anb5,a112),G1);;

g116:=StrongNormalFormNP(MulNP(g13,MulNP(g13,MulNP(g13,g13))),G1);;
gnb6:=StrongNormalFormNP(MulNP(g116,g26),G1);;

ynb6g:=MulNP(ynb6,gnb6);;

s112:=AddNP(anb6,ynb6g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);
#########################################################
Print("\n \n Case lambda1 zero, lambda2 nonzero, q12=1\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F:=Field(t1,t2);;
F1:=One(F);;
q:=E(3);;
q11:=q*F1;;
q12:=1;;
q21:=-q*F1;;
q22:=-q^2*F1;;

a13:=[[[4,4,4]],[F1]];;
a26:=[[[3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y26:=[[[5,5,5,5,5,5]],[F1]];;
g13:=[[[2,2,2]],[F1]];;
g26:=[[[1,1,1,1,1,1]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a26d:=AddNP(AddNP(a26,[[[]],[F1]],1,-t2),g26,F1,t2);;
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13,a13,
y26d,a26d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;
anb5:=StrongNormalFormNP(MulNP(anb4,a112),G1);;
anb6:=StrongNormalFormNP(MulNP(anb5,a112),G1);;

g116:=StrongNormalFormNP(MulNP(g13,MulNP(g13,MulNP(g13,g13))),G1);;
gnb6:=StrongNormalFormNP(MulNP(g116,g26),G1);;

ynb6g:=MulNP(ynb6,gnb6);;

s112:=AddNP(anb6,ynb6g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 zero, lambda2 nonzero, q12=E(6)\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F:=Field(t1,t2);;
F1:=One(F);;
q:=E(3);;
q11:=q*F1;;
q12:=E(6)*F1;;
q21:=-q/q12;;
q22:=-q^2*F1;;

a13:=[[[4,4,4]],[F1]];;
a26:=[[[3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y26:=[[[5,5,5,5,5,5]],[F1]];;
g13:=[[[2,2,2]],[F1]];;
g26:=[[[1,1,1,1,1,1]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a26d:=AddNP(AddNP(a26,[[[]],[F1]],1,-t2),g26,F1,t2);;
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13,a13,
y26d,a26d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;
anb5:=StrongNormalFormNP(MulNP(anb4,a112),G1);;
anb6:=StrongNormalFormNP(MulNP(anb5,a112),G1);;

g116:=StrongNormalFormNP(MulNP(g13,MulNP(g13,MulNP(g13,g13))),G1);;
gnb6:=StrongNormalFormNP(MulNP(g116,g26),G1);;

ynb6g:=MulNP(ynb6,gnb6);;

s112:=AddNP(anb6,ynb6g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);


#########################################################
Print("\n \n Case lambda1 zero, lambda2 nonzero, q12=E(6)^2\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F:=Field(t1,t2);;
F1:=One(F);;
q:=E(3);;
q11:=q*F1;;
q12:=E(6)^2*F1;;
q21:=-q/q12;;
q22:=-q^2*F1;;

a13:=[[[4,4,4]],[F1]];;
a26:=[[[3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y26:=[[[5,5,5,5,5,5]],[F1]];;
g13:=[[[2,2,2]],[F1]];;
g26:=[[[1,1,1,1,1,1]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a26d:=AddNP(AddNP(a26,[[[]],[F1]],1,-t2),g26,F1,t2);;
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13,a13,
y26d,a26d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");


d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;
anb5:=StrongNormalFormNP(MulNP(anb4,a112),G1);;
anb6:=StrongNormalFormNP(MulNP(anb5,a112),G1);;

g116:=StrongNormalFormNP(MulNP(g13,MulNP(g13,MulNP(g13,g13))),G1);;
gnb6:=StrongNormalFormNP(MulNP(g116,g26),G1);;

ynb6g:=MulNP(ynb6,gnb6);;

s112:=AddNP(anb6,ynb6g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);



#########################################################
Print("\n \n Case lambda1 zero, lambda2 nonzero, q12=E(6)^3\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F:=Field(t1,t2);;
F1:=One(F);;
q:=E(3);;
q11:=q*F1;;
q12:=E(6)^3*F1;;
q21:=-q/q12;;
q22:=-q^2*F1;;

a13:=[[[4,4,4]],[F1]];;
a26:=[[[3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y26:=[[[5,5,5,5,5,5]],[F1]];;
g13:=[[[2,2,2]],[F1]];;
g26:=[[[1,1,1,1,1,1]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a26d:=AddNP(AddNP(a26,[[[]],[F1]],1,-t2),g26,F1,t2);;
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13,a13,
y26d,a26d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");


d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;
anb5:=StrongNormalFormNP(MulNP(anb4,a112),G1);;
anb6:=StrongNormalFormNP(MulNP(anb5,a112),G1);;

g116:=StrongNormalFormNP(MulNP(g13,MulNP(g13,MulNP(g13,g13))),G1);;
gnb6:=StrongNormalFormNP(MulNP(g116,g26),G1);;

ynb6g:=MulNP(ynb6,gnb6);;

s112:=AddNP(anb6,ynb6g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);



#########################################################
Print("\n \n Case lambda1 zero, lambda2 nonzero, q12=E(6)^4\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F:=Field(t1,t2);;
F1:=One(F);;
q:=E(3);;
q11:=q*F1;;
q12:=E(6)^4*F1;;
q21:=-q/q12;;
q22:=-q^2*F1;;

a13:=[[[4,4,4]],[F1]];;
a26:=[[[3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y26:=[[[5,5,5,5,5,5]],[F1]];;
g13:=[[[2,2,2]],[F1]];;
g26:=[[[1,1,1,1,1,1]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a26d:=AddNP(AddNP(a26,[[[]],[F1]],1,-t2),g26,F1,t2);;
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13,a13,
y26d,a26d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");


d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;
anb5:=StrongNormalFormNP(MulNP(anb4,a112),G1);;
anb6:=StrongNormalFormNP(MulNP(anb5,a112),G1);;

g116:=StrongNormalFormNP(MulNP(g13,MulNP(g13,MulNP(g13,g13))),G1);;
gnb6:=StrongNormalFormNP(MulNP(g116,g26),G1);;

ynb6g:=MulNP(ynb6,gnb6);;

s112:=AddNP(anb6,ynb6g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);



#########################################################
Print("\n \n Case lambda1 zero, lambda2 nonzero, q12=E(6)^5\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F:=Field(t1,t2);;
F1:=One(F);;
q:=E(3);;
q11:=q*F1;;
q12:=E(6)^5*F1;;
q21:=-q/q12;;
q22:=-q^2*F1;;

a13:=[[[4,4,4]],[F1]];;
a26:=[[[3,3,3,3,3,3]],[F1]];;
y13:=[[[6,6,6]],[F1]];;
y26:=[[[5,5,5,5,5,5]],[F1]];;
g13:=[[[2,2,2]],[F1]];;
g26:=[[[1,1,1,1,1,1]],[F1]];;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(MulNP(g1,g2),g2);;

a26d:=AddNP(AddNP(a26,[[[]],[F1]],1,-t2),g26,F1,t2);;
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
y13,a13,
y26d,a26d,
y221,a221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);

Print("Computing Grobner basis... \n");
G1:=SGrobner(K1);

Print("Done. \n");
Print("Computing the coaction... \n");


d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
anb2:=StrongNormalFormNP(MulNP(a112,a112),G1);;
anb3:=StrongNormalFormNP(MulNP(anb2,a112),G1);;
anb4:=StrongNormalFormNP(MulNP(anb3,a112),G1);;
anb5:=StrongNormalFormNP(MulNP(anb4,a112),G1);;
anb6:=StrongNormalFormNP(MulNP(anb5,a112),G1);;

g116:=StrongNormalFormNP(MulNP(g13,MulNP(g13,MulNP(g13,g13))),G1);;
gnb6:=StrongNormalFormNP(MulNP(g116,g26),G1);;

ynb6g:=MulNP(ynb6,gnb6);;

s112:=AddNP(anb6,ynb6g,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("The difference is \n");
PrintNP(r112);

quit;

