LogTo("/home/agustin/gap-4.10.1/bin/ufo/lift-br2a-q-z.log");;

LoadPackage("GBNP");

GBNP.ConfigPrint("g2","g1","a2","a1","y2","y1");

g2:=[[[1]],[1]];
g1:=[[[2]],[1]];
a2:=[[[3]],[1]];
a1:=[[[4]],[1]];
y2:=[[[5]],[1]];
y1:=[[[6]],[1]];

#########################################################
Print("\n \n Case  lambda1, lambda2, lambda221 nonzero\n");

#q21=q

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;
t3:=Indeterminate(Rationals,"t3");;

F:=Field(t1,t2,t3);
F1:=1;;
q:=E(3);
q11:=q*F1;;
q12:=-q*F1;;
q21:=q*F1;;
q22:=-q*F1;;


a13:=[[[4,4,4]],[F1]];
a26:=[[[3,3,3,3,3,3]],[F1]];
y13:=[[[6,6,6]],[F1]];
y26:=[[[5,5,5,5,5,5]],[F1]];
g13:=[[[2,2,2]],[F1]];
g26:=[[[1,1,1,1,1,1]],[F1]];

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
g21:=MulNP(g2,g1);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(g2,g21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);
y221d:=AddNP(y221,[[[]],[F1]],1,-t3);

a13d:=AddNP(AddNP(a13,[[[]],[F1]],1,-t1),g13,F1,t1);;
a26d:=AddNP(AddNP(a26,[[[]],[F1]],1,-t2),g26,F1,t2);;
a221d:=AddNP(AddNP(a221,[[[]],[F1]],1,-t3),g221,F1,t3);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
a13d,y13d,
a26d,y26d,
a221d,y221d
];

G1:=SGrobner(K1);

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
yna2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
yna2d:=AddNP(yna2,MulNP(y2,y12),1,4*q*q21*t1);

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
ana2:=StrongNormalFormNP(MulNP(a112,a112),G1);;

g12:=MulNP(g1,g2);;
g112:=MulNP(g1,g12);;
gna2:=MulNP(g112,g112);;

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;

d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),F1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),F1,-q11*q12);;
dna2:=StrongNormalFormNP(MulNP(d112,d112),G1);;

dna2d:=AddNP(dna2,MulNP(d2,d12),1,4*q*q21*t1);

yna2dg:=MulNP(gna2,yna2d);;

sna2d:=AddNP(ana2,yna2dg,1,1);;
rna2d:=StrongNormalFormNP(AddNP(dna2d,sna2d,1,-1),G1);;

Print("\n The difference is \n ");
PrintNP(rna2d);

#######################################################

Print("\n \n Case  lambda1, lambda2, nonzero\n");

#q21=q^2

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;
t3:=Indeterminate(Rationals,"t3");;

F:=Field(t1,t2,t3);
F1:=1;;
q:=E(3);
q11:=q*F1;;
q21:=q^2*F1;;
q22:=-q*F1;;
q12:=q22^-1*q21^-1*F1;;

a13:=[[[4,4,4]],[F1]];
a26:=[[[3,3,3,3,3,3]],[F1]];
y13:=[[[6,6,6]],[F1]];
y26:=[[[5,5,5,5,5,5]],[F1]];
g13:=[[[2,2,2]],[F1]];
g26:=[[[1,1,1,1,1,1]],[F1]];

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
g21:=MulNP(g2,g1);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(g2,g21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);
y221d:=AddNP(y221,[[[]],[F1]],1,-t3);

a13d:=AddNP(AddNP(a13,[[[]],[F1]],1,-t1),g13,F1,t1);;
a26d:=AddNP(AddNP(a26,[[[]],[F1]],1,-t2),g26,F1,t2);;
a221d:=AddNP(AddNP(a221,[[[]],[F1]],1,-t3),g221,F1,t3);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
a13d,y13d,
a26d,y26d,
a221,y221
];

G1:=SGrobner(K1);

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
yna2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
yna2d:=AddNP(yna2,MulNP(y2,y12),1,4*q*q21*t1);

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
ana2:=StrongNormalFormNP(MulNP(a112,a112),G1);;

g12:=MulNP(g1,g2);;
g112:=MulNP(g1,g12);;
gna2:=MulNP(g112,g112);;

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;

d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),F1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),F1,-q11*q12);;
dna2:=StrongNormalFormNP(MulNP(d112,d112),G1);;

dna2d:=AddNP(dna2,MulNP(d2,d12),1,4*q*q21*t1);

yna2dg:=MulNP(gna2,yna2d);;

sna2d:=AddNP(ana2,yna2dg,1,1);;
rna2d:=StrongNormalFormNP(AddNP(dna2d,sna2d,1,-1),G1);;

Print("\n The difference is \n ");
PrintNP(rna2d);

#######################################################

Print("\n \n Case  lambda1, lambda2, nonzero\n");

#q21=1

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;
t3:=Indeterminate(Rationals,"t3");;

F:=Field(t1,t2,t3);
F1:=1;;
q:=E(3);
q11:=q*F1;;
q21:=F1;;
q22:=-q*F1;;
q12:=q22^-1*q21^-1*F1;;

a13:=[[[4,4,4]],[F1]];
a26:=[[[3,3,3,3,3,3]],[F1]];
y13:=[[[6,6,6]],[F1]];
y26:=[[[5,5,5,5,5,5]],[F1]];
g13:=[[[2,2,2]],[F1]];
g26:=[[[1,1,1,1,1,1]],[F1]];

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
g21:=MulNP(g2,g1);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(g2,g21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);
y221d:=AddNP(y221,[[[]],[F1]],1,-t3);

a13d:=AddNP(AddNP(a13,[[[]],[F1]],1,-t1),g13,F1,t1);;
a26d:=AddNP(AddNP(a26,[[[]],[F1]],1,-t2),g26,F1,t2);;
a221d:=AddNP(AddNP(a221,[[[]],[F1]],1,-t3),g221,F1,t3);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
a13d,y13d,
a26d,y26d,
a221,y221
];

G1:=SGrobner(K1);

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
yna2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
yna2d:=AddNP(yna2,MulNP(y2,y12),1,4*q*q21*t1);

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
ana2:=StrongNormalFormNP(MulNP(a112,a112),G1);;

g12:=MulNP(g1,g2);;
g112:=MulNP(g1,g12);;
gna2:=MulNP(g112,g112);;

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;

d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),F1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),F1,-q11*q12);;
dna2:=StrongNormalFormNP(MulNP(d112,d112),G1);;

dna2d:=AddNP(dna2,MulNP(d2,d12),1,4*q*q21*t1);

yna2dg:=MulNP(gna2,yna2d);;

sna2d:=AddNP(ana2,yna2dg,1,1);;
rna2d:=StrongNormalFormNP(AddNP(dna2d,sna2d,1,-1),G1);;

Print("\n The difference is \n ");
PrintNP(rna2d);


#########################################################
Print("\n \n Case  lambda1, lambda221 zero\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;
t3:=Indeterminate(Rationals,"t3");;

F:=Field(t1,t2,t3);
F1:=1;;
q:=E(3);
q11:=q*F1;;
q12:=q*F1;;
q21:=-q*F1;;
q22:=-q*F1;;


a13:=[[[4,4,4]],[F1]];
a26:=[[[3,3,3,3,3,3]],[F1]];
y13:=[[[6,6,6]],[F1]];
y26:=[[[5,5,5,5,5,5]],[F1]];
g13:=[[[2,2,2]],[F1]];
g26:=[[[1,1,1,1,1,1]],[F1]];

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

a21:=AddNP(MulNP(a2,a1),MulNP(a1,a2),F1,-q21);;
y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
g21:=MulNP(g2,g1);;

a221:=AddNP(MulNP(a2,a21),MulNP(a21,a2),F1,-q22*q21);;
y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
g221:=MulNP(g2,g21);;

y26d:=AddNP(y26,[[[]],[F1]],1,-t2);
a26d:=AddNP(AddNP(a26,[[[]],[F1]],1,-t2),g26,F1,t2);;


g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;

K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
a13,y13,
a26d,y26d,
a221,y221,
];

G1:=SGrobner(K1);

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
yna2:=StrongNormalFormNP(MulNP(y112,y112),G1);;

a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12);;
ana2:=StrongNormalFormNP(MulNP(a112,a112),G1);;

g12:=MulNP(g1,g2);;
g112:=MulNP(g1,g12);;
gna2:=MulNP(g112,g112);;

d1:=AddNP(a1,MulNP(g1,y1),1,1);;
d2:=AddNP(a2,MulNP(g2,y2),1,1);;

d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),F1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),F1,-q11*q12);;
dna2:=StrongNormalFormNP(MulNP(d112,d112),G1);;

yna2g:=MulNP(gna2,yna2);;

sna2:=AddNP(ana2,yna2g,1,1);;
rna2:=StrongNormalFormNP(AddNP(dna2,sna2,1,-1),G1);;

Print("\n The difference is \n ");
PrintNP(rna2);

