LogTo("/home/agustin/gap-4.10.1/bin/ufo/lift-br2a-q-1-PBW-wg11212.log");;

LoadPackage("GBNP");

GBNP.ConfigPrint("g2","g1","g11212","a2","a12","a112","a1","y2","y1");


#########################################################
Print("\n \n Case lambda1, lambda2, lambda3 nonzero\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;
t3:=Indeterminate(Rationals,"t3");;

F:=Field(t1,t2,t3);;
F1:=One(F);;
q:=E(3);
q11:=q*F1;;
q12:=-F1;;
q21:=F1;;
q22:=-F1;;


g2:=[[[1]],[F1]];
g1:=[[[2]],[F1]];
g11212:=[[[3]],[F1]];
a2:=[[[4]],[F1]];
a12:=[[[5]],[F1]];
a112:=[[[6]],[F1]];
a1:=[[[7]],[F1]];
y2:=[[[8]],[F1]];
y1:=[[[9]],[F1]];

a13:=MulNP(a1,MulNP(a1,a1));;
a22:=MulNP(a2,a2);;

y13:=MulNP(y1,MulNP(y1,y1));;
y22:=MulNP(y2,y2);;

g13:=MulNP(g1,MulNP(g1,g1));;
g22:=MulNP(g2,g2);;


a13d:=AddNP(AddNP(a13,[[[]],[F1]],F1,-t1),g13,F1,t1);;
a22d:=AddNP(AddNP(a22,[[[]],[F1]],F1,-t2),g22,F1,t2);;

y13d:=AddNP(y13,[[[]],[F1]],F1,-t1);
y22d:=AddNP(y22,[[[]],[F1]],F1,-t2);

gg:=AddNP(MulNP(g1,g2),MulNP(g2,g1),F1,-F1);;

g1a1:=AddNP(MulNP(g1,a1),MulNP(a1,g1),F1,-q11);;
g1a2:=AddNP(MulNP(g1,a2),MulNP(a2,g1),F1,-q12);;
g2a1:=AddNP(MulNP(g2,a1),MulNP(a1,g2),F1,-q21);;
g2a2:=AddNP(MulNP(g2,a2),MulNP(a2,g2),F1,-q22);;

g1y1:=AddNP(MulNP(g1,y1),MulNP(y1,g1),F1,-F1);;
g1y2:=AddNP(MulNP(g1,y2),MulNP(y2,g1),F1,-F1);;
g2y1:=AddNP(MulNP(g2,y1),MulNP(y1,g2),F1,-F1);;
g2y2:=AddNP(MulNP(g2,y2),MulNP(y2,g2),F1,-F1);;

a1y1:=AddNP(MulNP(a1,y1),MulNP(y1,a1),F1,-F1);;
a1y2:=AddNP(MulNP(a1,y2),MulNP(y2,a1),F1,-F1);;
a2y1:=AddNP(MulNP(a2,y1),MulNP(y1,a2),F1,-F1);;
a2y2:=AddNP(MulNP(a2,y2),MulNP(y2,a2),F1,-F1);;



r12:=AddNP(a12,AddNP(MulNP(a1,a2),MulNP(a2,a1),F1,-q12),F1,-F1);;
r112:=AddNP(a112,AddNP(MulNP(a1,a12),MulNP(a12,a1),F1,-q11*q12),F1,-F1);;

g12:=MulNP(g1,g2);;
g112:=MulNP(g1,g12);;
rg11212:=AddNP(g11212,MulNP(g112,g12),F1,-F1);;



K1:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
a13d,y13d,
a22d,y22d,
r12,r112,
rg11212
];

G1:=SGrobner(K1);

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;


d1:=AddNP(a1,MulNP(g1,y1),F1,F1);;
d2:=AddNP(a2,MulNP(g2,y2),F1,F1);;

d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),F1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),F1,-q11*q12);;
d11212:=StrongNormalFormNP(AddNP(MulNP(d112,d12),MulNP(d12,d112),F1,-q11^2*q12^2*q21*q22),G1);;

y11212:=StrongNormalFormNP(AddNP(MulNP(y112,y12),MulNP(y12,y112),F1,-q11^2*q12^2*q21*q22),G1);;


y11212g:=MulNP(g11212,y11212);;

a11212:=StrongNormalFormNP(AddNP(MulNP(a112,a12),MulNP(a12,a112),F1,-q11^2*q12^2*q21*q22),G1);;

s11212:=AddNP(a11212,y11212g,F1,F1);;
r11212:=AddNP(d11212,s11212,F1,-F1);;

r11212S:=StrongNormalFormNP(r11212,G1);;

Print("\n The difference is \n ");
PrintNP(r11212S);

a11212d:=AddNP(AddNP(AddNP(a11212,r11212S,F1,F1),[[[]],[F1]],F1,-t3),g11212,F1,t3);;

y11212d:=AddNP(y11212,[[[]],[F1]],F1,-t3);;

K2:=[
gg,
g1a1,g1a2,g2a1,g2a2,
g1y1,g1y2,g2y1,g2y2,
a1y1,a1y2,a2y1,a2y2,
a13d,y13d,
a22d,y22d,
r12,r112,
a11212d,y11212d,
rg11212
];

G2:=SGrobner(K2);

fna2:=StrongNormalFormNP(MulNP(d112,d112),G2);;
fna3:=StrongNormalFormNP(MulNP(fna2,d112),G2);;
fna4:=StrongNormalFormNP(MulNP(fna3,d112),G2);;
fna5:=StrongNormalFormNP(MulNP(fna4,d112),G2);;
fna6:=StrongNormalFormNP(MulNP(fna5,d112),G2);;

yyna2:=StrongNormalFormNP(MulNP(y112,y112),G2);;
yyna3:=StrongNormalFormNP(MulNP(yyna2,y112),G2);;
yyna4:=StrongNormalFormNP(MulNP(yyna3,y112),G2);;
yyna5:=StrongNormalFormNP(MulNP(yyna4,y112),G2);;
yyna6:=StrongNormalFormNP(MulNP(yyna5,y112),G2);;

aana2:=StrongNormalFormNP(MulNP(a112,a112),G2);;
aana3:=StrongNormalFormNP(MulNP(aana2,a112),G2);;
aana4:=StrongNormalFormNP(MulNP(aana3,a112),G2);;
aana5:=StrongNormalFormNP(MulNP(aana4,a112),G2);;
aana6:=StrongNormalFormNP(MulNP(aana5,a112),G2);;

ggna2:=MulNP(g112,g112);;
ggna3:=MulNP(ggna2,g112);;
ggna4:=MulNP(ggna3,g112);;
ggna5:=MulNP(ggna4,g112);;
ggna6:=MulNP(ggna5,g112);;

yyna6d:=StrongNormalFormNP(MulNP(ggna6,yyna6),G2);;

ssna6:=AddNP(aana6,yyna6d,F1,F1);;
rrna6:=AddNP(fna6,ssna6,F1,-F1);;

rrna6S:=StrongNormalFormNP(rrna6,G2);;

Print("\n The difference is \n ");
PrintNP(rrna6S);

Print("\n For the record, this is \n ");

rrna6S;



rrna6S;



